﻿Friend Class TestCreationFilter
    Implements Infragistics.Win.IUIElementCreationFilter

    Private mLeft As String
    Private mCentre As String
    Private mRight As String

    Public Sub AfterCreateChildElements(ByVal parent As Win.UIElement) Implements Win.IUIElementCreationFilter.AfterCreateChildElements
        Dim headerUIElement As Infragistics.Win.Misc.GroupBoxHeaderUIElement = TryCast(parent, Infragistics.Win.Misc.GroupBoxHeaderUIElement)
        If headerUIElement IsNot Nothing Then
            ' Get the position of the working rectangle.
            Dim topMostWorkingPoint As Integer = headerUIElement.Rect.Y + 1
            Dim leftMostWorkingPoint As Integer = headerUIElement.Rect.Left + 5
            Dim rightMostWorkingPoint As Integer = headerUIElement.Rect.Right - 5
            Dim heightOfWorkingPoint As Integer = headerUIElement.Rect.Height - 2

            ' First get the Expansion Indicator, and work out dimensions of area to work with.
            Dim expansionIndicatorUIElement As Infragistics.Win.Misc.GroupBoxExpansionIndicatorUIElement = DirectCast(parent.GetDescendant(GetType(Infragistics.Win.Misc.GroupBoxExpansionIndicatorUIElement)), Infragistics.Win.Misc.GroupBoxExpansionIndicatorUIElement)
            If expansionIndicatorUIElement IsNot Nothing Then
                topMostWorkingPoint = expansionIndicatorUIElement.Rect.Y
                leftMostWorkingPoint = expansionIndicatorUIElement.Rect.Right + 5
                rightMostWorkingPoint = headerUIElement.Rect.Right - 5
                heightOfWorkingPoint = expansionIndicatorUIElement.Rect.Height
            End If

            ' Get the original ImageAndTextUIElement.
            Dim originalTextUIElement As Infragistics.Win.ImageAndTextUIElement = DirectCast(parent.GetDescendant(GetType(Infragistics.Win.ImageAndTextUIElement)), Infragistics.Win.ImageAndTextUIElement)
            Dim workingAreaWidth As Integer = rightMostWorkingPoint - leftMostWorkingPoint

            ' Remove the existing header and rebuild.
            parent.ChildElements.Remove(originalTextUIElement)

            Dim newTextElement As Infragistics.Win.TextUIElement
            ' Create the Left text UI element.
            newTextElement = New Infragistics.Win.TextUIElement(parent, mLeft)
            newTextElement.TextVAlign = Win.VAlign.Middle
            newTextElement.TextHAlign = Win.HAlign.Left
            newTextElement.Rect = New Rectangle(leftMostWorkingPoint, topMostWorkingPoint, workingAreaWidth, heightOfWorkingPoint)
            parent.ChildElements.Add(newTextElement)
            ' Create the Centre text UI element.
            newTextElement = New Infragistics.Win.TextUIElement(parent, mCentre)
            newTextElement.TextVAlign = Win.VAlign.Middle
            newTextElement.TextHAlign = Win.HAlign.Center
            newTextElement.Rect = New Rectangle(leftMostWorkingPoint, topMostWorkingPoint, workingAreaWidth, heightOfWorkingPoint)
            parent.ChildElements.Add(newTextElement)
            ' Create the Right text UI element.
            newTextElement = New Infragistics.Win.TextUIElement(parent, mRight)
            newTextElement.TextVAlign = Win.VAlign.Middle
            newTextElement.TextHAlign = Win.HAlign.Right
            newTextElement.Rect = New Rectangle(leftMostWorkingPoint, topMostWorkingPoint, workingAreaWidth, heightOfWorkingPoint)
            parent.ChildElements.Add(newTextElement)
        End If
    End Sub

    Public Function BeforeCreateChildElements(ByVal parent As Win.UIElement) As Boolean Implements Win.IUIElementCreationFilter.BeforeCreateChildElements
        Return False
    End Function

    Public Sub New()
        MyBase.New()
    End Sub

    Friend Sub New(ByVal left As String, ByVal centre As String, ByVal right As String)
        Me.New()
        mLeft = left
        mCentre = centre
        mRight = right
    End Sub
End Class